## net.sf.saxon.instruct
Class ParentNodeConstructor

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.ParentNodeConstructor

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

Direct Known Subclasses:
  DocumentInstr, ElementCreator

    public abstract class ParentNodeConstructor

extends Instruction

An abstract class to act as a common parent for instructions that create element nodes and document nodes.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ParentNodeConstructor()`

Method Summary
`int` `computeCardinality()` Get the cardinality of the sequence returned by evaluating this instruction
`boolean` `createsNewNodes()` Determine whether this instruction creates new nodes.
`String` `getBaseURI()`
`int` `getCardinality()` Determine the static cardinality of the expression.
`Expression` `getContentExpression()` Get the expression that constructs the content of the element
`SchemaType` `getSchemaType()` Get the schema type chosen for validation; null if not defined
`int` `getValidationMode()` Get the validation mode for this instruction
`boolean` `isLazyConstruction()` Establish whether lazy construction is to be used
`boolean` `isNamespaceSensitive()` Determine whether the schema type is namespace sensitive.
`Iterator` `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`Expression` `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` `setBaseURI(String uri)`
`void` `setContentExpression(Expression content)` Set the expression that constructs the content of the element
`void` `setLazyConstruction(boolean lazy)` Indicate that lazy construction should (or should not) be used
`void` `setSchemaType(SchemaType type)` Set the schema type to be used for validation
`void` `setValidationMode(int mode)` Set the validation mode for the new element
`Expression` `simplify(StaticContext env)` Simplify an expression.
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, computeSpecialProperties, evaluateAsString, evaluateItem, getImplementationMethod, getInstructionInfo, getInstructionNameCode, getItemType, getSourceLocator, isXSLT, iterate, process, processLeavingTail, promote`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, effectiveBooleanValue, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### ParentNodeConstructor

    public ParentNodeConstructor()

Method Detail

### setBaseURI

    public void setBaseURI(String uri)

### getBaseURI

    public String getBaseURI()

### setLazyConstruction

    public void setLazyConstruction(boolean lazy)

  Indicate that lazy construction should (or should not) be used

  Parameters:
    `lazy` - set to true if lazy construction should be used

### isLazyConstruction

    public final boolean isLazyConstruction()

  Establish whether lazy construction is to be used

### setSchemaType

    public void setSchemaType(SchemaType type)

  Set the schema type to be used for validation

### getSchemaType

    public SchemaType getSchemaType()

  Get the schema type chosen for validation; null if not defined

### isNamespaceSensitive

    public boolean isNamespaceSensitive()

  Determine whether the schema type is namespace sensitive. The result is undefined if schemaType is null.

### setValidationMode

    public void setValidationMode(int mode)

  Set the validation mode for the new element

### getValidationMode

    public int getValidationMode()

  Get the validation mode for this instruction

  Returns:
    the validation mode, for example `Validation.STRICT` or `Validation.PRESERVE`

### setContentExpression

    public void setContentExpression(Expression content)

  Set the expression that constructs the content of the element

### getContentExpression

    public Expression getContentExpression()

  Get the expression that constructs the content of the element

### computeCardinality

    public int computeCardinality()

  Get the cardinality of the sequence returned by evaluating this instruction

  Overrides:
    `computeCardinality` in class `Instruction`
  Returns:
    the static cardinality

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in class `Instruction`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the parent pointer and location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate sub-expressions of this expression.

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation returns true.

  Overrides:
    `createsNewNodes` in class `Instruction`

### getCardinality

    public int getCardinality()

  Description copied from class: `Expression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Overrides:
    `getCardinality` in class `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

Copyright (C) Michael H. Kay. All rights reserved.